/*
 * nuqneH
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

/* Languages:
 *		1=Klingon
 *		2=English
 */

#ifndef	LANG
#define	LANG	1
#endif

#if	LANG==1
	#define	STR_TOO_FEW_ARGS	"mu' yapbe' bIghItlh'\n"
	#define	STR_NAME				"pong"
	#define	STR_NAMEWARNING	"paw' \"%s\" chaq\n",ad->Name
	#define	STR_UNEXP_TOKEN	"%d: mu' vIpIHbe (pab qab)\n",line_no
	#define	STR_NOFILE			"%s: vIlaDbe'\n",ifname
	#define	STR_STR_TOO_LONG	"%d: vuS bIvpu' (wa'SaD)\n",line_no
	#define	STR_BAD_TOKEN		"%d: pong DuH'be (%s)\n",line_no,Tok
	#define	STR_ARG_REQUIRED	"%d: %s poQ\n",line_no,Tok
	#define	STR_UNEXP_END		"%d: pay' De' rIn!\n",line_no
	#define	STR_BAD_DATA		"%d: muvtayDe' qab\n",line_no
	#define	STR_ARG_HASDEF		"%d: %s lo'laH",line_no,Tok
	#define	STR_MISSING_END	"\"end\" Qav'be.\n"
	#define	STR_NOT_AN_OPTION	"%d: DuH DuH'be\n",line_no
	#define	STR_TWO_DEFAULTS	"%d: cha'logh jIlaD DuH\n",line_no
	#define	STR_FATAL_PARSERR	"ParseFile HeghmoHQagh!\n"
#elif LANG==2
	#define	STR_TOO_FEW_ARGS	"Too few arguments.\n"
	#define	STR_NAME				"name"
	#define	STR_NAMEWARNING	"Warning! Argument \"%s\" may cause %s conflicts.\n",ad->Name,(lame)?"lame (C++)":"name"
	#define	STR_UNEXP_TOKEN	"%d: Unexpected token.\n",line_no
	#define	STR_NOFILE			"%s: Unable to read file.\n",ifname
	#define	STR_STR_TOO_LONG	"%d: String too long (1000).\n",line_no
	#define	STR_BAD_TOKEN		"%d: Invalid token \"%s\".\n",line_no,Tok
	#define	STR_ARG_REQUIRED	"%d: Argument is required.\n"
	#define	STR_UNEXP_END		"%d: Unexpected end of data.\n",line_no
	#define	STR_BAD_DATA		"%d: Bad data.\n",line_no
	#define	STR_ARG_HASDEF		"%d: Argument \"%s\" has default value.\n",line_no,Tok
	#define	STR_MISSING_END	"\"end\" missing at end.\n"
	#define	STR_NOT_AN_OPTION	"%d: Not a valid option.\n",line_no
	#define	STR_TWO_DEFAULTS	"%d: Default already specified.\n",line_no
	#define	STR_FATAL_PARSERR	"Fatal error in ParseFile!\n"
#else
#error Invalid language!
#endif

/* Define to enable argument wise mutexes. */
#undef	HAS_MUTEX

#ifdef	MTDEBUG
#include <MT.h>
#endif

#define	MARG	96	/* Max keys-1 in a line. */

static const char *Reserved[]={
	/* C */
	"int",
	"float",
	"double",
	"char",
	"long",
	"sizeof",
	"_Bool",
	"signed",
	"short",
	"unsigned",
	"static",
	"auto",
	"void",
	"volatile",
	"extern",
	"main",
	"default",
	"register",
	"inline",
	"struct",
	"union",
	"enum",
	"typedef",
	"switch",
	"case",
	"break",
	"continue",
	"goto",
	"return",
	"for",
	"while",
	"do",
	"if",
	"else",
	"const",
	"restrict",
	"_Complex",
	"_Imaginary",
	/* some C++ */
	"",
	"virtual",
	"using",
	"std",
	"class",
	"friend",
	"public",
	"protected",
	"private",
	"namespace",
	"new",
	"throw",
	"catch",
	"template",
	"explicit",
	"bool",
	"and",
	"or",
	"not",
	"delete",
	"this",
	0
};

struct ArgDesc {
	struct ArgDesc *Next;
	char *Name,*Alias,*Desc,*Validate;
	unsigned long int Mutex;
	char **p;
	union {
		double d;
		int i;
		char *s;
	} Default;
	int Flags,coffs;
	enum {
		AT_INT,
		AT_INTLIST,
		AT_FLOAT,
		AT_FLOATLIST,
		AT_STRING,
		AT_STRINGLIST,
		AT_QUAD,
		AT_QUADLIST,
		AT_BOOL,
		AT_REST,
		AT_ENUM,
		AT_ENUMLIST
	} Type;
};

#if	!defined(strdup) && !defined(HAS_STRDUP)
#define	strdup(x)	(strcpy(malloc(strlen(x)+1),x))
#endif

#define	ISLIST(x)	((x)==AT_INTLIST || (x)==AT_QUADLIST || (x)==AT_FLOATLIST || (x)==AT_STRINGLIST || (x)==AT_REST || (x)==AT_ENUMLIST)

static struct ArgDesc *FindAD(char *);

static unsigned long int flags;

static int MutexIdx=0;

#define	FLG_KEY			(1<<0L)
#define	FLG_INDIRECT	(1<<1L)
#define	FLG_VALIDATE	(1<<2L)
#define	FLG_REQTEST		(1<<3L)
#define	FLG_DEFAULTS	(1<<4L)
#define	FLG_SELFMUX		(1<<5L)
#define	FLG_DEFARG		(1<<6L)
#define	FLG_ENUMARG		(1<<7L)
#define	FLG_IGNORE		(1<<8L)
#define	FLG_SINGLEFILE	(1<<9L)
#define	FLG_USEQUAD		(1<<10L)
#define	FLG_NOHELP		(1<<11L)

#define	AFLG_HASDEFAULT	(1<<0L)
#define	AFLG_REQUIRED		(1<<1L)
#define	AFLG_RESTARG		(1<<2L)
#define	AFLG_DEFARG			(1<<3L)
#define	AFLG_SWITCH			(1<<4L)

static int line_no=1;

struct ArgDesc *ADRoot;

void TrimString(char *s);
char *FetchToken(FILE *fp);
void ParseFile(FILE *fp);
char **LSplit(char *lar,char dchar);

int main(int cnt,char *arg[])
{
const char *Typenamelist[]={
	"int",
	"intlist",
	"float",
	"floatlist",
	"string",
	"stringlist",
	"maxint",
	"maxintlist",
	"bool",
	"rest",
	"enum",
	"enumlist"
};
const char *Typetypelist[]={
	"long ",
	"long *",
	"double ",
	"double *",
	"char *",
	"char **",
	"long long int ",
	"long long int *",
	"#error Help!",
	"char **",
	"int ",
	"int *"
};

const char *Basetypelist[]={
	"#error Help!",
	"long",
	"#error Help!",
	"double",
	"#error Help!",
	"char *",
	"#error Help!",
	"long long",
	"#error Help!",
	"char *",
	"#error Help!",
	"int"
};
const char * const latextypenames[]={
	"$<$int$>$",
	"$<$int,\\ldots$>$",
	"$<$float$>$",
	"$<$float,\\ldots$>$",
	"$<$string$>$",
	"$<$string,\\ldots$>$",
	"$<$bigint$>$",
	"$<$bigint,\\ldots$>$",
	"",
	"$<$string$>$ [$<$string$>$ \\ldots]",
	"#error Help!",
	"#error Help!"
};
const char * const htmltypenames[]={
	"&lt;int&gt;",
	"&lt;int,...&gt;",
	"&lt;float&gt;",
	"&lt;float,...&gt;",
	"&lt;string&gt;",
	"&lt;string,...&gt;",
	"&lt;bigint&gt;",
	"&lt;bigint,...&gt;",
	"",
	"&lt;string&gt; [&lt;string&gt; ...]",
	"#error Help!",
	"#error Help!"
};

int i,n,t;
FILE *fp,*efp;
char *buf,**p,*hname;
struct ArgDesc *ad,*td1,*td2;
char *ifname=0,*ofname=0,*prefix="",*swc="";
int coffs=0;	/* Default for switch. */
int defidx=0,lame=0;
int latex=0,html=0;

if(cnt<2) {
	fprintf(stderr,STR_TOO_FEW_ARGS);
	return(20);
}

if(!(strcmp(arg[1],"-h") && strcmp(arg[1],"--help"))) {
	fprintf(stderr,"%s [-x] [-w] [-o <%s>] <%s>\n",arg[0],STR_NAME,STR_NAME);
	return(0);
}

for(i=1;i<cnt;i++) {
	if(!strncmp(arg[i],"-o",2)) {
		if(arg[i][2]) {
			ofname=&arg[i][2];
		} else {
			ofname=arg[++i];
			if(!ofname) {
				fprintf(stderr,"-o: -o <%s>\n",STR_NAME);
				return(5);
			}
		}
	} else if(!strncmp(arg[i],"-x",2)) {
		latex=1;
	} else if(!strncmp(arg[i],"-w",2)) {
		html=1;
	} else {
		ifname=arg[i];
	}
}

if(!ifname) {
	fprintf(stderr,"%s [-x] [-w] [-o <%s>] <%s>\n",arg[0],STR_NAME,STR_NAME);
	return(5);
}

if(!ofname) {
	if(latex) {
		ofname="muvtay.tex";
	} else if(html) {
		ofname="muvtay.html";
	} else {
		ofname="muvtay.c";
	}
}

if(fp=fopen(ifname,"rb")) {
	buf=malloc(256);
	ParseFile(fp);
	fclose(fp);

	/* Reverse order (so the args will be listed in the same order they appear in the definition). Blurg. */

	ad=ADRoot;
	td1=0;
	while(ad) {
		td2=ad;
		ad=ad->Next;
		td2->Next=td1;
		td1=td2;
	}
	ADRoot=td1;	
	
	if(flags&FLG_KEY) {
		coffs=-1;
	}

	if(flags&FLG_INDIRECT) {
		prefix="";
	} else {
		prefix="_";
	}

	ad=ADRoot;
	while(ad) {
		i=-1;
		lame=0;
		while(Reserved[++i]) {
			if(Reserved[i][0]==0) {
				lame=1;
				continue;
			}
			if(!strcmp(ad->Name,Reserved[i])) {
				fprintf(stderr,STR_NAMEWARNING);
			}
		}
		ad=ad->Next;
	}

	if(!strcmp(ofname,"-")) {
		fp=stdout;
	} else {
		fp=fopen(ofname,"wb");
	}

	if(fp) {
		if(latex) {
			fprintf(fp,"\\documentclass{article}\n\\usepackage[latin1]{inputenc}\n\\begin{document}\n"
				"\\section{Introduction}\n%\n% Short intoduction.\n%\n\\section{Overview}\n%\n% "
				"What does this program do? How does it do it?\n%\n\\section{Arguments}\n%\n% "
				"Need to write anything in general about the arguments?\n%\n");
			ad=ADRoot;
			while(ad) {
				swc=(!(flags&FLG_KEY)||(ad->Flags&AFLG_SWITCH))?"-":"";
				fprintf(fp,"\\subsection{");
				if(ad->Type==AT_ENUM || ad->Type==AT_ENUMLIST) {
					fprintf(fp,"%s%s ",swc,ad->Name);
					fprintf(fp,"\\{%s",ad->p[0]);
					i=0;
					while(ad->p[++i]) {
						fprintf(fp,"$|$%s",ad->p[i]);
					}
					fprintf(fp,"\\}");
				} else {
					fprintf(fp,"%s%s %s",swc,ad->Name,latextypenames[ad->Type]);
				}
				if(ad->Alias) {
					fprintf(fp," or ");
					if(ad->Type==AT_ENUM || ad->Type==AT_ENUMLIST) {
						fprintf(fp,"%s%s ",swc,ad->Alias);
						fprintf(fp,"\\{%s",ad->p[0]);
						i=0;
						while(ad->p[++i]) {
							fprintf(fp,"$|$%s",ad->p[i]);
						}
						fprintf(fp,"\\}");
					} else {
						fprintf(fp,"%s%s %s",swc,ad->Alias,latextypenames[ad->Type]);
					}
				}
				fprintf(fp,"}\n");
				if(ad->Flags&AFLG_HASDEFAULT) {
					fprintf(fp,"(Default: ");
					switch(ad->Type) {
					case	AT_INT:
					case	AT_QUAD:
						fprintf(fp,"%ld",ad->Default.i);
					break;
					case	AT_FLOAT:
						fprintf(fp,"%lf",ad->Default.d);
					break;
					case	AT_STRING:
					case	AT_ENUM:
						fprintf(fp,"%s",ad->Default.s);
					break;
					}
					fprintf(fp,")\n");
				}
				fprintf(fp,"%\n% Description of argument goes here.\n");
				if(ad->Desc) {
					for(i=n=0;i<strlen(ad->Desc);i++) {
						if(n>70 && isspace(ad->Desc[i])) {
							fputc('\n',fp);
							n=0;
						} else {
							fputc(ad->Desc[i],fp);
						}
						n++;
					}
					fputc('\n',fp);
				}
				fprintf(fp,"%\n");
				ad=ad->Next;
			}
			fprintf(fp,"\\end{document}\n");
			goto exit_cleanup;
		} /* latex */

		if(html) {
			fprintf(fp,
				"<!DOCTYPE html PUBLIC \"-//W3C//DTD HTML 3.2//EN\">\n<HTML>\n<HEAD>\n"
				"<META NAME=\"generator\" CONTENT=\"nuqneH\">\n<TITLE>"
				"%s</TITLE>\n</HEAD>\n\n<BODY>\n<H2>Introduction</H2>\n<P>Introduction here.</P>"
				"<BR>\n<H2>Overview</H2>\n<P>Overview here.</P>\n<BR><H2>Arguments</H2>\n<DL>\n","Reference");
			ad=ADRoot;
			while(ad) {
				swc=(!(flags&FLG_KEY)||(ad->Flags&AFLG_SWITCH))?"-":"";
				fprintf(fp,"<DT>");
				if(ad->Type==AT_ENUM || ad->Type==AT_ENUMLIST) {
					fprintf(fp,"<strong>%s%s</strong> ",swc,ad->Name);
					fprintf(fp,"{%s",ad->p[0]);
					i=0;
					while(ad->p[++i]) {
						fprintf(fp,"|%s",ad->p[i]);
					}
					fprintf(fp,"}");
				} else {
					fprintf(fp,"<strong>%s%s</strong> %s",swc,ad->Name,htmltypenames[ad->Type]);
				}
				if(ad->Alias) {
					fprintf(fp," or ");
					if(ad->Type==AT_ENUM || ad->Type==AT_ENUMLIST) {
						fprintf(fp,"<strong>%s%s</strong> ",swc,ad->Alias);
						fprintf(fp,"{%s",ad->p[0]);
						i=0;
						while(ad->p[++i]) {
							fprintf(fp,"|%s",ad->p[i]);
						}
						fprintf(fp,"}");
					} else {
						fprintf(fp,"<strong>%s%s</strong> %s",swc,ad->Alias,htmltypenames[ad->Type]);
					}
				}
				fprintf(fp,"\n<DD>");
				if(ad->Flags&AFLG_HASDEFAULT) {
					fprintf(fp,"(Default: ");
					switch(ad->Type) {
					case	AT_INT:
					case	AT_QUAD:
						fprintf(fp,"%ld",ad->Default.i);
					break;
					case	AT_FLOAT:
						fprintf(fp,"%lf",ad->Default.d);
					break;
					case	AT_STRING:
					case	AT_ENUM:
						fprintf(fp,"%s",ad->Default.s);
					break;
					}
					fprintf(fp,")\n");
				}
				fprintf(fp,"\n<! Description of argument goes here. >\n");
				if(ad->Desc) {
					for(i=n=0;i<strlen(ad->Desc);i++) {
						if(n>70 && isspace(ad->Desc[i])) {
							fputc('\n',fp);
							n=0;
						} else {
							fputc(ad->Desc[i],fp);
						}
						n++;
					}
					fputc('\n',fp);
				} else {
					fprintf(fp,"Write something here.\n");
				}
				fprintf(fp,"\n");
				ad=ad->Next;
			}
			fprintf(fp,"</DL>\n</BODY>\n</HTML>");

			goto exit_cleanup;
		}

		fprintf(fp,"\n#ifdef	__SUNPRO_CC\n"
			"#pragma error_messages off\n"
			"#endif\n");

		if(flags&FLG_ENUMARG) {
			p=malloc(sizeof(char *)*2048);	/* Max 2048 options. */
			i=0;

			if(!(flags&FLG_SINGLEFILE)) {
				hname=malloc(strlen(ofname)+2);
				if(strrchr(ofname,'.')) {
					strcpy(hname,ofname);
					strcpy(strrchr(hname,'.'),".h");
				} else {
					strcpy(hname,ofname);
					strcat(hname,".h");
				}
				efp=fopen(hname,"wb");
				fprintf(efp,"/* nuqneH chenmoHta' 'oH! */\n\n"
									 "#ifndef NUQNEH_EXTERNAL_H__\n"
									 "#define NUQNEH_EXTERNAL_H__\n\n");
				fprintf(fp,"#ifndef NUQNEH_EXTERNAL_H__\n"
									 "#include \"%s\"\n"
									 "#endif\n",hname);
			} else {
				efp=fp;
			}
			
			fprintf(efp,"enum OptEnum_nq {");
			ad=ADRoot;
			while(ad) {
				if(ad->p) {
					n=-1;
					while(ad->p[++n]) {
						for(t=0;t<i;t++) {
							if(!strcmp(ad->p[n],p[t])) {
								break;
							}
						}
						if(t==i) {
							fprintf(efp,"\n\tOPT_%s,",ad->p[n]);
							p[i++]=ad->p[n];
						}
					}
				}
				ad=ad->Next;
			}
			fprintf(efp,"\n\tdummy_opt_nq\n};\n");

			if(!(flags&FLG_SINGLEFILE)) {
				fprintf(efp,"\n\n#endif\n");
				fclose(efp);
				free(hname);
			}
			
			fprintf(fp,"char *OptNames_nq[] NQ_VUNUSED ={");
			for(n=0;n<i;n++) {
				fprintf(fp,"\n\t\"%s\",",p[n]);
			}
			fprintf(fp,"\n\t0\n};\n");
			free(p);
		} else {
			fprintf(fp,"char **OptNames_nq NQ_VUNUSED =0;\n");
		}

		ad=ADRoot;
		while(ad) {
			if(ad->p) {
				fprintf(fp,"struct {\n\tenum OptEnum_nq Id;");
				fprintf(fp,"\n\tchar *s;\n} enames_%s_nq[] = {",ad->Name);
				i=-1;
				while(ad->p[++i]) {
					fprintf(fp,"\n\t{OPT_%s,\"%s\"},",ad->p[i],ad->p[i]);
				}
				fprintf(fp,"\n\t{dummy_opt_nq,0}\n};\n");
			}
			ad=ad->Next;
		}

		fprintf(fp,"static const struct {\n\tchar *s;\n\tint l,Id;\n} ArgList_nq[]={\n");
		ad=ADRoot;
		n=i=0;
		while(ad) {
			if(ad->Type==AT_BOOL) {
				if(flags&FLG_KEY && !(ad->Flags&AFLG_SWITCH)) {
					fprintf(fp,"\t{\"%s\",%d,%d},\t/* %s */\n",ad->Name,strlen(ad->Name)+1,i,Typenamelist[ad->Type]);
				} else {
					fprintf(fp,"\t{\"-%s\",%d,%d},\t/* %s */\n",ad->Name,strlen(ad->Name)+2,i,Typenamelist[ad->Type]);
				}
				if(ad->Alias) {
					if(flags&FLG_KEY && !(ad->Flags&AFLG_SWITCH)) {
						fprintf(fp,"\t{\"%s\",%d,%d},\t/* %s */\n",ad->Alias,strlen(ad->Alias)+1,i,Typenamelist[ad->Type]);
					} else {
						fprintf(fp,"\t{\"-%s\",%d,%d},\t/* %s */\n",ad->Alias,strlen(ad->Alias)+2,i,Typenamelist[ad->Type]);
					}
				}
				n++;
			} else {
				if(flags&FLG_KEY && !(ad->Flags&AFLG_SWITCH)) {
					fprintf(fp,"\t{\"%s=\",%d,%d},\t/* %s */\n",ad->Name,strlen(ad->Name)+1,i,Typenamelist[ad->Type]);
					fprintf(fp,"\t{\"%s\",%d,%d},\t/* internal alias */\n",ad->Name,strlen(ad->Name)+1,i);
					if(ad->Alias) {
						fprintf(fp,"\t{\"%s=\",%d,%d},\t/* %s */\n",ad->Alias,strlen(ad->Alias)+1,i,Typenamelist[ad->Type]);
						fprintf(fp,"\t{\"%s\",%d,%d},\t/* internal alias */\n",ad->Alias,strlen(ad->Alias)+1,i);
						n+=2;
					}
					n+=2;
				} else {
					fprintf(fp,"\t{\"-%s\",%d,%d},\t/* %s */\n",ad->Name,strlen(ad->Name)+1,i,Typenamelist[ad->Type]);
					if(ad->Alias) {
						fprintf(fp,"\t{\"-%s\",%d,%d},\t/* %s */\n",ad->Alias,strlen(ad->Alias)+1,i,Typenamelist[ad->Type]);
						n++;
					}
					n++;
				}
			}
			if(ad->Flags&AFLG_DEFARG) {
				defidx=n-1;
			}
			ad=ad->Next;
			i++;
		}
		fprintf(fp,"\t{0,0,%d}\n};\n",i);

		/* Separate typedefs so we can add offsetof()s later. */
		
		fprintf(fp,"\ntypedef struct {");
		ad=ADRoot;
		while(ad) {
			if(ad->Type!=AT_BOOL) {
				fprintf(fp,"\n\t%s%s%s;",Typetypelist[ad->Type],prefix,ad->Name);
			}
			ad=ad->Next;
		}
		fprintf(fp,"\n\tint dummy_nq;\n} qam_value;");

		fprintf(fp,"\ntypedef struct {");
		ad=ADRoot;
		while(ad) {
			if(ISLIST(ad->Type)) {
				fprintf(fp,"\n\tint %s%s;",prefix,ad->Name);
			}
			ad=ad->Next;
		}
		fprintf(fp,"\n\tint dummy_nq;\n} qam_count;");

		fprintf(fp,"\ntypedef struct {");
		ad=ADRoot;
		while(ad) {
/*			fprintf(fp,"\n\t\tunsigned int %s:1;",ad->Name);*/	/* Too bad. Bitfields are nice. */
			fprintf(fp,"\n\tunsigned char %s%s;",prefix,ad->Name);
			ad=ad->Next;
		}
		fprintf(fp,"\n\tunsigned char dummy_nq;\n} qam_test;");

		fprintf(fp,"\n\nstruct qam_nqs {\n"
			"\tqam_value VALUE;\n"
			"\tqam_count COUNT;\n"
			"\tqam_test  TEST;\n"
		);

		fprintf(fp,"} ARGS={{");
		ad=ADRoot;
		while(ad) {
			if(ad->Flags&AFLG_HASDEFAULT) {
				switch(ad->Type) {
				case	AT_INT:
					fprintf(fp,"%d,",ad->Default.i);
				break;
				case	AT_FLOAT:
					fprintf(fp,"%f,",ad->Default.d);
				break;
				case	AT_STRING:
					fprintf(fp,"\"%s\",",ad->Default.s);
				break;
				case	AT_ENUM:
					fprintf(fp,"OPT_%s,",ad->Default.s);
				break;
				default:
					fprintf(stderr,"%s: ghuSwI' Hat",ad->Name);
				}
			} else if(ad->Type!=AT_BOOL) {
				fprintf(fp,"0,");
			}
			ad=ad->Next;
		}
		fprintf(fp,"0},{0},{0}};\ntypedef struct qam_nqs qam_nq;\n");

		fprintf(fp,"static const long Meta_nq[] NQ_VUNUSED ={\n\toffsetof(qam_nq,VALUE),offsetof(qam_nq,COUNT),offsetof(qam_nq,TEST),sizeof(qam_nq),");
		ad=ADRoot;
		while(ad) {
			if(ad->Type!=AT_BOOL) {
				if(ISLIST(ad->Type)) {
					fprintf(fp,"\n\t%d,offsetof(qam_nq,VALUE)+offsetof(qam_value,%s%s),offsetof(qam_nq,COUNT)+offsetof(qam_count,%s%s),offsetof(qam_nq,TEST)+offsetof(qam_test,%s%s),",ad->Type,prefix,ad->Name,prefix,ad->Name,prefix,ad->Name);
				} else {
					fprintf(fp,"\n\t%d,offsetof(qam_nq,VALUE)+offsetof(qam_value,%s%s),0,offsetof(qam_nq,TEST)+offsetof(qam_test,%s%s),",ad->Type,prefix,ad->Name,prefix,ad->Name);
				}
			} else {
				fprintf(fp,"\n\t%d,0,0,offsetof(qam_nq,TEST)+offsetof(qam_test,%s%s),",ad->Type,prefix,ad->Name);
			}
			ad=ad->Next;
		}
		fprintf(fp,"-1};\n");

		fprintf(fp,"static const char * const Meta_names_nq[] NQ_VUNUSED ={");
		ad=ADRoot;
		while(ad) {
			fprintf(fp,"\"%s\",",ad->Name);
			ad=ad->Next;
		}
		fprintf(fp,"0};\n");

		fprintf(fp,"int idx_nq=0,t_nq=0,lmatch_nq=0,alen_nq=0,fixidx_nq=0;\nchar **p_nq NQ_VUNUSED =0,*cp_nq NQ_VUNUSED =0,*argfix_nq=0;\n");
		if(MutexIdx>0) {
			fprintf(fp,"unsigned long int Mutex_nq=0,Flags_nq=0,TempMux_nq=0;\n");
		} else {
			fprintf(fp,"unsigned long int Flags_nq=0;\n");
		}
		if(flags&FLG_USEQUAD) {
			fprintf(fp,"#ifndef	NQ_64\n#error Unrecognised non-C99-compliant compiler while using maxint. Define NQ_64 to compile anyway.\n#endif\n");
		}
		fprintf(fp,"\nfree(malloc(1));\t/* Initialise eventual memory tracking libraries. */\n"
			"atexit(atexithandler_nq);\n\n");
		if(flags&FLG_REQTEST) {
			fprintf(fp,"if(cnt<2) {\n\tfprintf(stderr,\"No arguments. Use %%s -h for help.\\n\",arg[0]);\n\treturn(0);\n}\n\n");
		}
		if(!(flags&FLG_NOHELP)) {
			fprintf(fp,"if(cnt>1 && !(strcmp(arg[1],\"-h\") && strcmp(arg[1],\"--help\") && strcmp(arg[1],\"?\"))) {\n\tprintf(");
			ad=ADRoot;
			while(ad) {
				if(flags&FLG_KEY && !(ad->Flags&AFLG_SWITCH)) {
				 if(ad->Type==AT_BOOL) {
						if(ad->Alias) {
							sprintf(buf," or %s",ad->Alias);
						} else {
							buf[0]=0;
						}
						fprintf(fp,"\n\t\t\"   %s%s (boolean)",ad->Name,buf);
					} else if(ad->Type==AT_ENUM) {
						if(ad->Alias) {
							sprintf(buf," or %s=<x>",ad->Alias);
						} else {
							buf[0]=0;
						}
						fprintf(fp,"\n\t\t\"   %s=<x>%s where <x>={%s",ad->Name,buf,ad->p[0]);
						i=0;
						while(ad->p[++i]) {
							fprintf(fp,"|%s",ad->p[i]);
						}
						fprintf(fp,"}");
					} else if(ad->Type==AT_ENUMLIST) {
						if(ad->Alias) {
							sprintf(buf," or %s=<x-list>",ad->Alias);
						} else {
							buf[0]=0;
						}
						fprintf(fp,"\n\t\t\"   %s=<x-list>%s where <x>={%s",ad->Name,buf,ad->p[0]);
						i=0;
						while(ad->p[++i]) {
							fprintf(fp,"|%s",ad->p[i]);
						}
						fprintf(fp,"}");
					} else {
						if(ad->Alias) {
							sprintf(buf," or %s=<%s>",ad->Alias,Typenamelist[ad->Type]);
						} else {
							buf[0]=0;
						}
						fprintf(fp,"\n\t\t\"   %s=<%s>%s",ad->Name,Typenamelist[ad->Type],buf);
					}
				} else {
					if(ad->Type==AT_BOOL) {
						if(ad->Alias) {
							sprintf(buf," or -%s",ad->Alias);
						} else {
							buf[0]=0;
						}
						fprintf(fp,"\n\t\t\"   -%s%s (boolean)",ad->Name,buf);
					} else if(ad->Type==AT_ENUM) {
						if(ad->Alias) {
							sprintf(buf," or -%s <x>",ad->Alias);
						} else {
							buf[0]=0;
						}
						fprintf(fp,"\n\t\t\"   -%s <x>%s where <x>={%s",ad->Name,buf,ad->p[0]);
						i=0;
						while(ad->p[++i]) {
							fprintf(fp,"|%s",ad->p[i]);
						}
						fprintf(fp,"}");
					} else if(ad->Type==AT_ENUMLIST) {
						if(ad->Alias) {
							sprintf(buf," or -%s <x-list>",ad->Alias);
						} else {
							buf[0]=0;
						}
						fprintf(fp,"\n\t\t\"   -%s <x-list>%s where <x>={%s",ad->Name,buf,ad->p[0]);
						i=0;
						while(ad->p[++i]) {
							fprintf(fp,"|%s",ad->p[i]);
						}
						fprintf(fp,"}");
					} else {
						if(ad->Alias) {
							sprintf(buf," or -%s <%s>",ad->Alias,Typenamelist[ad->Type]);
						} else {
							buf[0]=0;
						}
						fprintf(fp,"\n\t\t\"   -%s <%s>%s",ad->Name,Typenamelist[ad->Type],buf);
					}
				}
	
				if(ad->Flags&AFLG_REQUIRED) {
					fprintf(fp,"\\n\\t(Required argument)");
				} else if(ad->Flags&AFLG_HASDEFAULT) {
					fprintf(fp,"\\n\\t(Default: ");
					switch(ad->Type) {
					case	AT_INT:
						fprintf(fp,"%d)",ad->Default.i);
					break;
					case	AT_FLOAT:
						fprintf(fp,"%f)",ad->Default.d);
					break;
					case	AT_STRING:
					case	AT_ENUM:
						i=-1;
						while(ad->Default.s[++i]) {
							switch(ad->Default.s[i]) {
							case	'"':
								fprintf(fp,"\\\"");
							break;
							case	'%':
								fprintf(fp,"%%%%");
							break;
							default:
								fprintf(fp,"%c",ad->Default.s[i]);
							}
						}
						fprintf(fp,")");
					break;
					default:
						fprintf(stderr,"nuqjathl?!?\n");
						exit(10);
					}
				}
	
				if(ad->Desc) {
					fprintf(fp,"\\n      ");
					i=-1;n=0;
					while(ad->Desc[++i]) {
						if((i&63)==63) {
							n=1;
						}
						switch(ad->Desc[i]) {
						case	'"':
							fprintf(fp,"\\\"");
						break;
						case	'%':
							fprintf(fp,"%%%%");
						break;
						case	' ':
							if(n) {
								fprintf(fp,"\\n     ");	/* One space less. */
								n=0;
							}
						default:
							fprintf(fp,"%c",ad->Desc[i]);
						}
					}
				}
	
				fprintf(fp,"\\n\"");
				ad=ad->Next;
			}
			fprintf(fp,");\n\treturn(0);\n}\n\n");
		}	/* if(!(flags&FLG_NOHELP)) */

		if(flags&FLG_DEFAULTS) {
			fprintf(fp,"RedoParse_nq:\n\n");
		}

		fprintf(fp,
			"idx_nq=0;\nwhile(++idx_nq<cnt) {\n"
			"\targfix_nq=arg[idx_nq];\n"
			"\tfixidx_nq=idx_nq;\n"
			"\tt_nq=-1;\n\talen_nq=0;\n\tlmatch_nq=-1;\n\twhile(ArgList_nq[++t_nq].s) {\n\t\t"
			"if(ArgList_nq[t_nq].l>alen_nq && !strncmp(arg[idx_nq],ArgList_nq[t_nq].s,ArgList_nq[t_nq].l)) {"
			"\n\t\t\tlmatch_nq=t_nq;\n\t\t\talen_nq=ArgList_nq[t_nq].l;\n\t\t}\n\t}\n\tif(lmatch_nq!=-1) {\n\t\tt_nq=lmatch_nq;\n\t}\n"
			"\tswitch(ArgList_nq[t_nq].Id) {\n"
		);

		ad=ADRoot;
		i=0;
		while(ad) {
			fprintf(fp,"\tcase	%d:\t/* %s */\n",i,ad->Name);
			if(ad->Flags&AFLG_DEFARG) {
				fprintf(fp,"\t\tlabdefault_nq:\n");
			}
			if(flags&FLG_SELFMUX) {
				fprintf(fp,"\t\tif(ARGS.TEST.%s%s) {\n\t\t\tfprintf(stderr,\"Duplicate specification of \\\"%%s\\\".\\n\",\"%s\");\n\t\t\treturn(EXIT_FAILURE);\n\t\t}\n",prefix,ad->Name,ad->Name);
			}
			fprintf(fp,"\t\tARGS.TEST.%s%s=LINEFLAG_NQ;\n",prefix,ad->Name);
			if(ad->Mutex) {
				fprintf(fp,"\t\tif(Mutex_nq&0x%08lx) {\n\t\t\tfprintf(stderr,\"Argument \\\"%%s\\\" violates mutex condition.\\n\",\"%s\");"
					"\n\t\t\tFlags_nq|=2;\n\t\t}\n\t\tMutex_nq|=0x%08lx;\n",ad->Mutex,ad->Name,ad->Mutex);
			}
			switch(ad->Type) {
			case	AT_QUAD:
				fprintf(fp,"\t\tif(arg[idx_nq][ArgList_nq[t_nq].l%+d]!=0) {"
					"\n\t\t\tcp_nq=(&arg[idx_nq][ArgList_nq[t_nq].l]);\n\t\t} else {\n"
					"\t\t\tcp_nq=(arg[++idx_nq]);\n\t\t}\n"
					"\t\tif(!isdigit(cp_nq[0])) {\n\t\t\tfprintf(stderr,\"Warning. Bad digit for %s.\\n\");"
					"\n\t\t}\n\t\tARGS.VALUE.%s%s=(cp_nq)?atoll(cp_nq):0LL;\n",ad->coffs,ad->Name,prefix,ad->Name);
			break;
			case	AT_QUADLIST:
				fprintf(fp,
					"\t\tif(arg[idx_nq][ArgList_nq[t_nq].l%+d]!=0) {"
					"\n\t\t\tp_nq=LSplit_nq(&arg[idx_nq][ArgList_nq[t_nq].l],&t_nq);\n\t\t} else {\n"
					"\t\t\tp_nq=LSplit_nq(arg[++idx_nq],&t_nq);\n\t\t}\n"
					"\t\tARGS.VALUE.%s%s=(%s)malloc(sizeof(%s)*t_nq);\n"
					"\t\tMemTrackList_nq[MemTrackIdx_nq++]=ARGS.VALUE.%s%s;\n"
					"\t\tARGS.COUNT.%s%s=t_nq;\n"
					"\t\tfor(t_nq--;t_nq>=0;t_nq--) {\n\t\t\tARGS.VALUE.%s%s[t_nq]=(p_nq[t_nq])?atoll(p_nq[t_nq]):0LL;\n"
					"\t\t\tif(!isdigit(p_nq[t_nq][0])) {\n"
					"\t\t\t\tfprintf(stderr,\"Warning. Bad digit for %s.\\n\");\n"
					"\t\t\t\tFlags_nq|=2;\n"
					"\t\t\t}\n\t\t}\n\t\tfree(p_nq);\n"
					,ad->coffs,prefix,ad->Name,Typetypelist[ad->Type],Basetypelist[ad->Type],prefix,ad->Name,prefix,ad->Name,prefix,ad->Name,ad->Name);
			break;
			case	AT_ENUMLIST:
				fprintf(fp,"\t\tif(arg[idx_nq][ArgList_nq[t_nq].l%+d]!=0) {"
					"\n\t\t\tcp_nq=(&arg[idx_nq][ArgList_nq[t_nq].l]);\n\t\t} else {\n"
					"\t\t\tcp_nq=(arg[++idx_nq]);\n\t\t}\n",ad->coffs);
				fprintf(fp,"\t\tif(!cp_nq) {\n\t\t\tfprintf(stderr,\"Missing value for %s.\\n\");\n\t\t\treturn(EXIT_FAILURE);\n\t\t}\n",ad->Name);
				fprintf(fp,
					"\t\tp_nq=LSplit_nq(cp_nq,&t_nq);\n"
					"\t\tARGS.VALUE.%s%s=(%s)malloc(sizeof(%s)*t_nq);\n"
					"\t\tMemTrackList_nq[MemTrackIdx_nq++]=ARGS.VALUE.%s%s;\n"
					"\t\tARGS.COUNT.%s%s=t_nq;\n"
					"\t\tfor(t_nq--;t_nq>=0;t_nq--) {\n"
					"\t\tint t2_nq;\n\t\t\tt2_nq=-1;\n\t\t\twhile(enames_%s_nq[++t2_nq].s) {\n"
					"\t\t\t\tif(!strcmp(enames_%s_nq[t2_nq].s,p_nq[t_nq])) {\n\t\t\t\t\tARGS.VALUE.%s%s[t_nq]=enames_%s_nq[t2_nq].Id;\n"
					"\t\t\t\t\tbreak;\n\t\t\t\t}\n\t\t\t}\n\t\t\tif(!enames_%s_nq[t2_nq].s) {\n"
					"\t\t\t\tfprintf(stderr,\"%%s is not valid for %s.\\n\",p_nq[t_nq]);\n"
					"\t\t\t\tFlags_nq|=2;\n"
					"\t\t\t}\n\t\t}\n\t\tfree(p_nq);\n",
					prefix,ad->Name,Typetypelist[ad->Type],Basetypelist[ad->Type],prefix,ad->Name,prefix,
					ad->Name,ad->Name,ad->Name,prefix,ad->Name,ad->Name,ad->Name,ad->Name);
			break;
			case	AT_ENUM:
				fprintf(fp,"\t\tif(arg[idx_nq][ArgList_nq[t_nq].l%+d]!=0) {"
					"\n\t\t\tcp_nq=(&arg[idx_nq][ArgList_nq[t_nq].l]);\n\t\t} else {\n"
					"\t\t\tcp_nq=(arg[++idx_nq]);\n\t\t}\n",ad->coffs);
				fprintf(fp,"\t\tif(!cp_nq) {\n\t\t\tfprintf(stderr,\"Missing value for %s.\\n\");\n\t\t\treturn(EXIT_FAILURE);\n\t\t}\n",ad->Name);
				fprintf(fp,"\t\tt_nq=-1;\n\t\twhile(enames_%s_nq[++t_nq].s) {\n\t\t\tif(!strcmp("
					"enames_%s_nq[t_nq].s,cp_nq)) {\n\t\t\t\tbreak;\n\t\t\t}\n\t\t}\n"
					"\t\tif(enames_%s_nq[t_nq].s) {\n\t\t\tARGS.VALUE.%s%s=enames_%s_nq[t_nq].Id;\n"
					"\t\t} else {\n\t\t\tfprintf(stderr,\"%%s is not valid for %%s.\\n\",cp_nq,\"%s\");"
					"\n\t\t\tFlags_nq|=2;\n\n\t\t}\n",
					ad->Name,ad->Name,ad->Name,prefix,ad->Name,ad->Name,ad->Name);
			break;
			case	AT_INT:
				fprintf(fp,"\t\tif(arg[idx_nq][ArgList_nq[t_nq].l%+d]!=0) {"
					"\n\t\t\tcp_nq=(&arg[idx_nq][ArgList_nq[t_nq].l]);\n\t\t} else {\n"
					"\t\t\tcp_nq=(arg[++idx_nq]);\n\t\t}\n"
					"\t\tif(cp_nq) {\n"
					"\t\t\tif(!isdigit(cp_nq[0])) {\n\t\t\t\tfprintf(stderr,\"Warning. Bad digit for %s.\\n\");"
					"\n\t\t\t}\n\t\t\tARGS.VALUE.%s%s=atoi_nq(cp_nq);\n"
					"\t\t} else {\n\t\t\tfprintf(stderr,\"Warning! Missing value for %s!\\n\");\n\t\t\tARGS.TEST.%s%s=0;\n\t\t}\n"
					,ad->coffs,ad->Name,prefix,ad->Name,ad->Name,prefix,ad->Name);
			break;
			case	AT_INTLIST:
				fprintf(fp,
					"\t\tif(arg[idx_nq][ArgList_nq[t_nq].l%+d]!=0) {"
					"\n\t\t\tp_nq=LSplit_nq(&arg[idx_nq][ArgList_nq[t_nq].l],&t_nq);\n\t\t} else {\n"
					"\t\t\tp_nq=LSplit_nq(arg[++idx_nq],&t_nq);\n\t\t}\n"
					"\t\tARGS.VALUE.%s%s=(%s)malloc(sizeof(%s)*t_nq);\n"
					"\t\tMemTrackList_nq[MemTrackIdx_nq++]=ARGS.VALUE.%s%s;\n"
					"\t\tARGS.COUNT.%s%s=t_nq;\n"
					"\t\tfor(t_nq--;t_nq>=0;t_nq--) {\n\t\t\tARGS.VALUE.%s%s[t_nq]=atoi_nq(p_nq[t_nq]);\n"
					"\t\t\tif(!isdigit(p_nq[t_nq][0])) {\n"
					"\t\t\t\tfprintf(stderr,\"Warning. Bad digit for %s.\\n\");\n"
					"\t\t\t\tFlags_nq|=2;\n"
					"\t\t\t}\n\t\t}\n\t\tfree(p_nq);\n"
					,ad->coffs,prefix,ad->Name,Typetypelist[ad->Type],Basetypelist[ad->Type],prefix,ad->Name,prefix,ad->Name,prefix,ad->Name,ad->Name);
			break;
			case	AT_FLOAT:
				fprintf(fp,"\t\tif(arg[idx_nq][ArgList_nq[t_nq].l%+d]!=0) {\n"
				"\t\t\tcp_nq=&arg[idx_nq][ArgList_nq[t_nq].l];\n\t\t} else {\n"
				"\t\t\tcp_nq=arg[++idx_nq];\n\t\t}\n\t\tif(cp_nq) {\n"
				"\t\t\tARGS.VALUE.%s%s=atof_nq(cp_nq);\n\t\t} else {\n"
				"\t\t\tfprintf(stderr,\"Missing value for \\\"%s\\\"!\\n\");\n"
				"\t\t\tARGS.TEST.%s%s=0;\n\t\t}\n",ad->coffs,prefix,ad->Name,ad->Name,prefix,ad->Name);
			break;
			case	AT_FLOATLIST:
				fprintf(fp,
					"\t\tif(arg[idx_nq][ArgList_nq[t_nq].l%+d]!=0) {"
					"\n\t\t\tp_nq=LSplit_nq(&arg[idx_nq][ArgList_nq[t_nq].l],&t_nq);\n\t\t} else {\n"
					"\t\t\tp_nq=LSplit_nq(arg[++idx_nq],&t_nq);\n\t\t}\n"
					"\t\tARGS.VALUE.%s%s=(%s)malloc(sizeof(%s)*t_nq);\n"
					"\t\tMemTrackList_nq[MemTrackIdx_nq++]=ARGS.VALUE.%s%s;\n"
					"\t\tARGS.COUNT.%s%s=t_nq;\n"
					"\t\tfor(t_nq--;t_nq>=0;t_nq--) {\n\t\t\tARGS.VALUE.%s%s[t_nq]=atof_nq(p_nq[t_nq]);\n"
					"\t\t}\n"
					"\t\tfree(p_nq);\n"
					,ad->coffs,prefix,ad->Name,Typetypelist[ad->Type],Basetypelist[ad->Type],prefix,ad->Name,prefix,ad->Name,prefix,ad->Name);
			break;
			case	AT_STRING:
				fprintf(fp,"\t\tif(arg[idx_nq][ArgList_nq[t_nq].l%+d]!=0) {"
					"\n\t\t\tARGS.VALUE.%s%s=(&arg[idx_nq][ArgList_nq[t_nq].l]);\n\t\t} else {\n"
					"\t\t\tARGS.VALUE.%s%s=(arg[++idx_nq]);\n\t\t}\n",ad->coffs,prefix,ad->Name,prefix,ad->Name);
				fprintf(fp,"\t\tif(!ARGS.VALUE.%s%s) {\n"
					"\t\t\tfprintf(stderr,\"Missing value for \\\"%%s\\\".\\n\",\"%s\");\n"
					"\t\t\tFlags_nq|=2;\n\t\t\tARGS.TEST.%s%s=0;\n\t\t}\n",prefix,ad->Name,ad->Name,prefix,ad->Name);
			break;
			case	AT_STRINGLIST:
				fprintf(fp,
					"\t\tif(arg[idx_nq][ArgList_nq[t_nq].l%+d]!=0) {"
					"\n\t\t\tp_nq=LSplit_nq(&arg[idx_nq][ArgList_nq[t_nq].l],&t_nq);\n\t\t} else {\n"
					"\t\t\tp_nq=LSplit_nq(arg[++idx_nq],&t_nq);\n\t\t}\n"
					"\t\tARGS.VALUE.%s%s=p_nq;\n"
					"\t\tARGS.COUNT.%s%s=t_nq;\n"
					"\t\tMemTrackList_nq[MemTrackIdx_nq++]=p_nq;\n"
					,ad->coffs,prefix,ad->Name,prefix,ad->Name);
			break;
			case	AT_BOOL:
				/* Do nothing more. */
			break;
			case	 AT_REST:
				/* Do something. */
				fprintf(fp,
					"\t\tARGS.COUNT.%s%s=cnt-idx_nq-1;\n"
					"\t\tARGS.VALUE.%s%s=(char **)malloc(sizeof(char *)*(1+ARGS.COUNT.%s%s));\n"
					"\t\tMemTrackList_nq[MemTrackIdx_nq++]=ARGS.VALUE.%s%s;\n"
					"\t\tt_nq=idx_nq+1;\n"
					"\t\twhile(++idx_nq<cnt) {\n"
					"\t\t\tARGS.VALUE.%s%s[idx_nq-t_nq]=arg[idx_nq];\n"
					"\t\t}\n"
					"\t\tARGS.VALUE.%s%s[idx_nq-t_nq]=0;\n",
					prefix,ad->Name,prefix,ad->Name,prefix,ad->Name,prefix,ad->Name,prefix,ad->Name,prefix,ad->Name);
			break;
			}
			fprintf(fp,"\tbreak;\n");
			ad=ad->Next;
			i++;
		}

		fprintf(fp,"\tdefault:\n");
		if(flags&FLG_DEFARG) {
			fprintf(fp,"\t\tif(!(Flags_nq&4)) {\n"
				"\t\t\tFlags_nq|=4;\n"
				"\t\t\tidx_nq--;\n"
				"\t\t\tfixidx_nq=idx_nq;\n"
				"\t\t\targfix_nq=arg[fixidx_nq];\n"
				"\t\t\targ[idx_nq]=ArgList_nq[%d].s;\n"
				"\t\t\tt_nq=%d;\n"
				"\t\t\tgoto labdefault_nq;\n"
				"\t\t}\n",defidx,defidx);
		}
		fprintf(fp,"\t\tfprintf(stderr,\"Unrecognised argument \\\"%%s\\\".\\n\",arg[idx_nq]);");
		fprintf(fp,"\n\t\tFlags_nq|=2;");
		fprintf(fp,"\n\t}/* switch */\n"
			"\targ[fixidx_nq]=argfix_nq;\n"
			"}/* while */\n\nt_nq=0;\nidx_nq=0;\n");


		if(flags&FLG_DEFAULTS) {
			fprintf(fp,"if(ARGS.TEST.%sread && !(Flags_nq&1)) {"
				"%s"
				"\n\tRescueArgs(ARGS.VALUE.%sread);"
				"%s"
				"\n\tARGS.TEST.%swrite=0;\n\t"
				"ARGS.TEST.%sread=0;\n\t"
				"Flags_nq|=1;\n\tgoto RedoParse_nq;\n} else if(ARGS.TEST.%swrite) {\n\t"
				"SaveArgs(ARGS.VALUE.%swrite);\n}\n\n",
				prefix,
				(MutexIdx>0)?"\n\tTempMux_nq=Mutex_nq;":"",
				prefix,
				(MutexIdx>0)?"\n\tMutex_nq&=~(TempMux_nq);":"",
				prefix,prefix,prefix,prefix);
		}

		ad=ADRoot;
		while(ad) {
			if(ad->Flags&AFLG_REQUIRED) {
				fprintf(fp,"if(!ARGS.TEST.%s%s) {\n\tfprintf(stderr,\"Required argument \\\"%%s\\\" missing.\\n\",\"%s\");\n\tt_nq++;\n}\n",prefix,ad->Name,ad->Name);
			}
			ad=ad->Next;
		}

		if(flags&FLG_REQTEST) {
			fprintf(fp,"if(t_nq) {\n\tfprintf(stderr,\"\\n%%d required argument%%s missing.\\n\",t_nq,(t_nq>1)?\"s\":\"\");"
				"\n}\n\n");
		}


		if(!(flags&FLG_INDIRECT)) {
			ad=ADRoot;
			while(ad) {
				if(ad->Type!=AT_BOOL) {
					fprintf(fp,"#define	%s	ARGS.VALUE.%s%s\n",ad->Name,prefix,ad->Name);
				}
				fprintf(fp,"#define	%s_test	ARGS.TEST.%s%s\n",ad->Name,prefix,ad->Name);
				if(ISLIST(ad->Type)) {
					fprintf(fp,"#define	%s_count	ARGS.COUNT.%s%s\n",ad->Name,prefix,ad->Name);
				}
				i=-1;
				ad=ad->Next;
			}
		}

		ad=ADRoot;
		while(ad) {
			if(ad->Validate) {
				fprintf(fp,"if(ARGS.TEST.%s%s && !(",prefix,ad->Name);
				i=-1;
				while(ad->Validate[++i]) {
					if(ad->Validate[i]=='$') {
						fprintf(fp,"ARGS.VALUE.%s%s",prefix,ad->Name);
						continue;
					}
					fputc(ad->Validate[i],fp);
				}
				fprintf(fp,")) {\n\tfprintf(stderr,\"Argument \\\"%%s\\\" violates input constraint \\\"%%s\\\".\\n\",\"%s\",\"",ad->Name);
				i=-1;
				while(ad->Validate[++i]) {
					switch(ad->Validate[i]) {
					case	'"':
						fprintf(fp,"\\\"");
					break;
					case	'%':
						fprintf(fp,"%%");
					break;
					default:
						fputc(ad->Validate[i],fp);
					}
				}
				fprintf(fp,"\");\n\tidx_nq++;\n}\n");
			}
			ad=ad->Next;
		}

		if(flags&FLG_VALIDATE) {
			fprintf(fp,"if(idx_nq) {\n\tfprintf(stderr,\"\\n%%d input constraint%%s violated.\\n\",idx_nq,(idx_nq>1)?\"s\":\"\");\n}\n\n");
		}

		if(!(flags&FLG_IGNORE)) {
			fprintf(fp,"if(idx_nq || t_nq || (Flags_nq&2)) {\n\tfprintf(stderr,\"Aborted.\\n\");"
			"\n\treturn(EXIT_FAILURE);\n}\n\n");
		} else if(flags&(FLG_VALIDATE|FLG_REQTEST)) {
			fprintf(fp,"if(idx_nq || t_nq || (Flags_nq&2)) {\n\tfprintf(stderr,\"Aborted.\\n\");"
			"\n\treturn(EXIT_FAILURE);\n}\n\n");
		}

		fprintf(fp,"\n#ifdef	__SUNPRO_CC\n"
			"#pragma error_messages default\n"
			"#endif\n");

exit_cleanup:

	if(strcmp(ofname,"-")) {
			fclose(fp);
		}
	}

	while(ADRoot) {
		ad=ADRoot->Next;
		free(ADRoot->Name);
		if(ADRoot->p) {
			free(ADRoot->p);
		}
		if(ADRoot->Desc) {
			free(ADRoot->Desc);
		}
		if(ADRoot->Alias) {
			free(ADRoot->Alias);
		}
		if(ADRoot->Validate) {
			free(ADRoot->Validate);
		}
		if(ADRoot->Flags&AFLG_HASDEFAULT && ADRoot->Type==AT_STRING) {
			free(ADRoot->Default.s);
		}
		free(ADRoot);
		ADRoot=ad;
	}

	free(buf);
} else {
	fprintf(stderr,STR_NOFILE);
	return(20);
}

return(0);
}

char *FetchToken(FILE *fp)
{
static char Tok[1024];
char z,oz=0;
int idx;
enum {
	FTMODE_INIT,
	FTMODE_TOK
} mode=FTMODE_INIT,omode=FTMODE_INIT;

idx=0;
while(z=fgetc(fp),!feof(fp)) {
	switch(z) {
	case	'\n':
		line_no++;
	case	' ':
	case	'\t':
	case	'\r':
		if(mode==FTMODE_TOK) {
			break;
		}
	continue;

	case	'=':
		if(mode==FTMODE_INIT) {
			Tok[idx++]=z;
		} else {
			ungetc(z,fp);
		}
	break;

	case	'#':
		while(z=fgetc(fp),z!='\n' && !feof(fp));
		line_no++;
	continue;

	case	'{':
		Tok[idx++]=z;
		while(z=fgetc(fp),z!='}' && !feof(fp)) {
			if(z=='\n') {
				line_no++;
			}
			Tok[idx++]=z;
		}
		Tok[idx++]=z;
		mode=FTMODE_TOK;
	continue;

	case	'*':
		if(oz=='/') {
			idx=(idx)?idx-1:idx;
			mode=omode;
			while(z=fgetc(fp),!feof(fp)) {
				if(z=='/' && oz=='*') {
					break;
				}
				if(z=='\n') {
					line_no++;
				}
				oz=z;
			}
		} else {
			Tok[idx++]=z;
		}
	continue;

	default:
		if(/*mode==FTMODE_INIT && */z=='"') {
			if(oz=='"') {
				Tok[idx++]='"';
			}
			while(z=fgetc(fp),z!='"' && !feof(fp)) {
				Tok[idx++]=z;
				if(idx>1022) {
					fprintf(stderr,STR_STR_TOO_LONG);
					return(0);
				}
			}
		} else {
			Tok[idx++]=z;
		}
		omode=mode;
		mode=FTMODE_TOK;
		oz=z;
	continue;
	}
	break;
}

if(!idx) {
	return(0);
}

Tok[idx]=0;

#ifdef	DEBUG
printf("Tok: \"%s\"\n",Tok);
#endif

return(Tok);
}

void ParseFile(FILE *fp)
{
char *Tok,*tp,**p;
enum {
	PMODE_OPTSECTION,
	PMODE_ARGSECTION,
	PMODE_REQSECTION,
	PMODE_ALIASSECTION,
	PMODE_VALSECTION,
	PMODE_DESCSECTION,
	PMODE_DEFSECTION,
	PMODE_MEXSECTION,
	PMODE_ENTER_SECTION,
	PMODE_NONE
} mode=PMODE_NONE;
const struct {
	const char * const Tok;
	const enum {
		TOK_SECTION,
		TOK_OPTIONS,
		TOK_ARGS,
		TOK_VALIDATE,
		TOK_DESC,
		TOK_ALIAS,
		TOK_DEFAULT,
		TOK_REQUIRED,
		TOK_MUTEX,
		TOK_END,
		TOK_EQL,
		TOK_BYE,
		TOK_OTHER
	} Id;
} TokId[]={
	{"section",TOK_SECTION},
	{"options",TOK_OPTIONS},
	{"args",TOK_ARGS},
	{"alias",TOK_ALIAS},
	{"validate",TOK_VALIDATE},
	{"test",TOK_VALIDATE},
	{"desc",TOK_DESC},
	{"help",TOK_DESC},
	{"required",TOK_REQUIRED},
	{"mutex",TOK_MUTEX},
	{"description",TOK_DESC},
	{"default",TOK_DEFAULT},
	{"end",TOK_END},
	{"=",TOK_EQL},
	{"finished",TOK_BYE},
	{0,TOK_OTHER},
};
const struct {
	const char * const Name;
	const int Type;
} TypeDefs[]={
		{"int",AT_INT},
		{"[int]",AT_INTLIST},
		{"float",AT_FLOAT},
		{"[float]",AT_FLOATLIST},
		{"string",AT_STRING},
		{"[string]",AT_STRINGLIST},
		{"bool",AT_BOOL},
		{"maxint",AT_QUAD},
		{"[maxint]",AT_QUADLIST},
		{"rest",AT_REST},
		{0,0},
		{"enum",AT_ENUM}
};

int i,Id;
char Nambuf[32];
struct ArgDesc *ad;

while(Tok=FetchToken(fp)) {
	i=-1;
	while(TokId[++i].Tok) {
		if(!strcmp(Tok,TokId[i].Tok)) {
			break;
		}
	}
	Id=TokId[i].Id;
Retry:
	switch(Id) {
	case	TOK_BYE:
		return;
	break;
	case	TOK_SECTION:
		if(mode==PMODE_NONE) {
			mode=PMODE_ENTER_SECTION;
		} else {
			Id=TOK_OTHER;
			goto Retry;
		}
	break;
	case	TOK_MUTEX:
#ifdef	HAS_MUTEX
		fprintf(stderr,"\"mutex\" chu'be'\n");
		exit(10);
#endif
	case	TOK_VALIDATE:
	case	TOK_OPTIONS:
	case	TOK_DESC:
	case	TOK_REQUIRED:
	case	TOK_ARGS:
	case	TOK_DEFAULT:
	case	TOK_ALIAS:
		if(mode==PMODE_ENTER_SECTION) {
			switch(Id) {
				case	TOK_MUTEX:
					mode=PMODE_MEXSECTION;
				break;
				case	TOK_VALIDATE:
					flags|=FLG_VALIDATE;
					mode=PMODE_VALSECTION;
				break;
				case	TOK_OPTIONS:
					mode=PMODE_OPTSECTION;
				break;
				case	TOK_DESC:
					mode=PMODE_DESCSECTION;
				break;
				case	TOK_REQUIRED:
					flags|=FLG_REQTEST;
					mode=PMODE_REQSECTION;
				break;
				case	TOK_ARGS:
					mode=PMODE_ARGSECTION;
				break;
				case	TOK_DEFAULT:
					mode=PMODE_DEFSECTION;
				break;
				case	TOK_ALIAS:
					mode=PMODE_ALIASSECTION;
				break;
			}
		} else {
			Id=TOK_OTHER;
			goto Retry;
		}
	break;

/*****/

	case	TOK_END:
		switch(mode) {
		default:
			fprintf(stderr,STR_UNEXP_TOKEN);
			exit(10);
		case	PMODE_MEXSECTION:
			MutexIdx++;
		case	PMODE_ARGSECTION:
		case	PMODE_OPTSECTION:
		case	PMODE_ALIASSECTION:
		case	PMODE_DESCSECTION:
		case	PMODE_DEFSECTION:
		case	PMODE_REQSECTION:
		case	PMODE_VALSECTION:
			mode=PMODE_NONE;
		}
	break;
	case	TOK_EQL:
			fprintf(stderr,STR_UNEXP_TOKEN);
			exit(10);
	break;
	case	TOK_OTHER:
		switch(mode) {
		case	PMODE_MEXSECTION:
			ad=FindAD(Tok);
			if(ad) {
				ad->Mutex|=(1<<MutexIdx);
			} else {
				fprintf(stderr,STR_BAD_TOKEN);
				exit(10);
			}
		break;
		case	PMODE_DEFSECTION:
			ad=FindAD(Tok);
			if(ad) {
				Tok=FetchToken(fp);
				if(Tok && !strcmp(Tok,"=")) {
					Tok=FetchToken(fp);
					if(Tok) {
						if(ad->Flags&AFLG_REQUIRED) {
							fprintf(stderr,STR_ARG_REQUIRED);
							exit(10);
						}
						ad->Flags|=AFLG_HASDEFAULT;
						switch(ad->Type) {
						case	AT_INT:
							ad->Default.i=atoi(Tok);
						break;
						case	AT_FLOAT:
							ad->Default.d=atof(Tok);
						break;
						case	AT_BOOL:
							ad->Default.i=atoi(Tok);
						break;
						case	AT_STRING:
							ad->Default.s=strdup(Tok);
						break;
						case	AT_ENUM:
							ad->Default.s=strdup(Tok);
						break;
						default:
							ad->Flags&=~AFLG_HASDEFAULT;
							fprintf(stderr,STR_BAD_DATA);							
						}
					} else {
						fprintf(stderr,STR_UNEXP_END);
						exit(10);
					}
				} else {
					fprintf(stderr,STR_UNEXP_TOKEN);
					exit(10);
				}
			} else {
				fprintf(stderr,STR_BAD_TOKEN);
				exit(10);
			}
		break;
		case	PMODE_REQSECTION:
			ad=FindAD(Tok);
			if(ad) {
				if(ad->Flags&AFLG_HASDEFAULT) {
					fprintf(stderr,STR_ARG_HASDEF);
					exit(10);
				} else {
					ad->Flags|=AFLG_REQUIRED;
				}
			} else {
				fprintf(stderr,STR_BAD_TOKEN);
				exit(10);
			}
		break;
		case	PMODE_VALSECTION:
			ad=FindAD(Tok);
			if(ad) {
				Tok=FetchToken(fp);
				if(Tok && !strcmp(Tok,"=")) {
					Tok=FetchToken(fp);
					if(Tok) {
						ad->Validate=strdup(Tok);
					} else {
						fprintf(stderr,STR_UNEXP_END);
						exit(10);
					}
				} else {
					fprintf(stderr,STR_UNEXP_TOKEN);
					exit(10);
				}
			} else {
				fprintf(stderr,STR_BAD_TOKEN);
				exit(10);
			}
		break;
		case	PMODE_DESCSECTION:
			ad=FindAD(Tok);
			if(ad) {
				Tok=FetchToken(fp);
				if(Tok && !strcmp(Tok,"=")) {
					Tok=FetchToken(fp);
					if(Tok) {
						ad->Desc=strdup(Tok);
					} else {
						fprintf(stderr,STR_UNEXP_END);
						exit(10);
					}
				} else {
					fprintf(stderr,STR_UNEXP_TOKEN);
					exit(10);
				}
			} else {
				fprintf(stderr,STR_BAD_TOKEN);
				exit(10);
			}
		break;
		case	PMODE_ALIASSECTION:
			ad=FindAD(Tok);
			if(ad) {
				Tok=FetchToken(fp);
				if(Tok && !strcmp(Tok,"=")) {
					Tok=FetchToken(fp);
					if(Tok) {
						ad->Alias=strdup(Tok);
					} else {
						fprintf(stderr,STR_UNEXP_END);
						exit(10);
					}
				} else {
					fprintf(stderr,STR_UNEXP_TOKEN);
					exit(10);
				}
			} else {
				fprintf(stderr,STR_BAD_TOKEN);
				exit(10);
			}
		break;
		case	PMODE_OPTSECTION:
			if(!strcmp(Tok,"key")) {
				flags|=FLG_KEY;
			} else if(!strcmp(Tok,"switch")) {
				flags&=~FLG_KEY;
			} else if(!strcmp(Tok,"ignore")) {
				flags|=FLG_IGNORE;
			} else if(!strcmp(Tok,"indirect")) {
				flags|=FLG_INDIRECT;
			} else if(!strcmp(Tok,"defaults")) {
				flags|=FLG_DEFAULTS;
				ad=malloc(sizeof(struct ArgDesc));	
				ad->Name=strdup("read");
				ad->Alias=0;
				ad->Desc=strdup("Specifies a file to load the commandline arguments from.");
				ad->Validate=0;
				ad->Flags=0;
				ad->p=0;
				ad->Mutex=0;
				ad->Type=AT_STRING;
				ad->Next=ADRoot;
				ADRoot=ad;
				ad=malloc(sizeof(struct ArgDesc));	
				ad->Name=strdup("write");
				ad->Alias=0;
				ad->Desc=strdup("Specifies a file to save the commandline arguments to.");
				ad->Validate=0;
				ad->Flags=0;
				ad->p=0;
				ad->Mutex=0;
				ad->Type=AT_STRING;
				ad->Next=ADRoot;
				ADRoot=ad;
			} else if(!strcmp(Tok,"selfmux")) {
				flags|=FLG_SELFMUX;
			} else if(!strcmp(Tok,"singlefile")) {
				flags|=FLG_SINGLEFILE;
			} else if(!strcmp(Tok,"nohelp")) {
				flags|=FLG_NOHELP;
/*			} else if(!strcmp(Tok,"")) {
*/
			} else {
				fprintf(stderr,STR_NOT_AN_OPTION);
			}
		break;
		case	PMODE_ARGSECTION:
			ad=malloc(sizeof(struct ArgDesc));	
			ad->Alias=0;
			ad->Desc=0;
			ad->Validate=0;
			ad->Flags=0;
			ad->p=0;
			ad->Mutex=0;
			strcpy(Nambuf,Tok);
			if(Nambuf[0]=='-') {
				i=0;
				while(Nambuf[++i]) {
					Nambuf[i-1]=Nambuf[i];
				}
				Nambuf[i-1]=0;
				ad->Flags|=AFLG_SWITCH;
			}
			ad->coffs=((flags&FLG_KEY) && !(ad->Flags&AFLG_SWITCH))?-1:0;	/* Coffs for each argument. */
			Tok=FetchToken(fp);
			if(FindAD(Nambuf)) {
				fprintf(stderr,"%d: cha'logh %s DaghIthl",line_no,Nambuf);
				exit(10);
			}
			if(Tok && !strcmp(Tok,"=")) {
				ad->Name=strdup(Nambuf);
				Tok=FetchToken(fp);
				i=strlen(Tok);
				if(Tok[i-1]=='*') {
					if(flags&FLG_DEFARG) {
						fprintf(stderr,STR_TWO_DEFAULTS);
						exit(10);
					} else {
						flags|=FLG_DEFARG;
						ad->Flags|=AFLG_DEFARG;
						Tok[i-1]=0;
					}
				}
				if(Tok[0]=='{') {	/* Enumeration arguments. */
					flags|=FLG_ENUMARG;
					tp=strchr(Tok,'}');
					if(tp) {
						ad->Type=AT_ENUM;
						*tp=0;
						p=LSplit(&Tok[1],',');
						i=-1;
						while(p[++i]) {
							TrimString(p[i]);
						}
						ad->p=p;
					} else {
						fprintf(stderr,STR_UNEXP_TOKEN);
						exit(10);
					}
				} else if(Tok[0]=='[' && Tok[1]=='{') {	/* Enumeration list */
					flags|=FLG_ENUMARG;
					tp=strchr(Tok,'}');
					if(tp) {
						ad->Type=AT_ENUMLIST;
						*tp=0;
						p=LSplit(&Tok[2],',');
						i=-1;
						while(p[++i]) {
							TrimString(p[i]);
						}
						ad->p=p;
					} else {
						fprintf(stderr,STR_UNEXP_TOKEN);
						exit(10);
					}
				} else {
					i=-1;
					while(TypeDefs[++i].Name) {
						if(!strcmp(TypeDefs[i].Name,Tok)) {
							break;
						}
					}			
					if(TypeDefs[i].Name) {
						ad->Type=TypeDefs[i].Type;
						if(ad->Type==AT_QUAD || ad->Type==AT_QUADLIST) {
							flags|=FLG_USEQUAD;
						}
					} else {
						fprintf(stderr,STR_UNEXP_TOKEN);
						exit(10);
					}
				}
				ad->Next=ADRoot;
				ADRoot=ad;
			} else {
				fprintf(stderr,STR_UNEXP_TOKEN);
				exit(10);
			}
		break;
		default:
			fprintf(stderr,STR_UNEXP_TOKEN);
			exit(10);
		}
	break;
	default:
		fprintf(stderr,STR_FATAL_PARSERR);
		exit(10);
	}
}

if(mode!=PMODE_NONE) {
	fprintf(stderr,STR_MISSING_END);
}

}

static struct ArgDesc *FindAD(char *n)
{
struct ArgDesc *ad;
ad=ADRoot;
while(ad) {
	if(!strcmp(ad->Name,n)) {
		break;
	}
	ad=ad->Next;
}
return(ad);
}


#define	S(x)	((x)==dchar)
#define	C	lar[lp]

char **LSplit(char *lar,char dchar)
{
int	c=0,lp= -1,bp=0,qm=0;
char	**W,*B0;

W=malloc(strlen(lar)+MARG*sizeof(char *)+1);
B0=(char *)&W[MARG];
if(W) {
 do{
  while(lp++,S(C));
  if(C){
   W[c++] = &B0[bp];
   while(B0[bp++] = C,lp++,(!S(C)||qm)&&(C!=0)) {
		if(C=='"') {
			qm^=1;
		}
	}
   B0[bp++] = 0;
  }
 }while(C);
 W[c]=0;
}
return(W);
}

#undef S
#undef C

void TrimString(char *s)
{
int i;

if(s) {
	i=strlen(s);
	if(i) {
		while(isspace(s[--i])) {
			s[i]=0;
		}
	}
	i=-1;
	while(isspace(s[++i]));
	if(i) {
		memmove(s,&s[i],strlen(s)-i+1);
	}
}

}


/* vi:set ts=3: */


